// AStarDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AStar.h"
#include "AStarDlg.h"
#include <memory.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

#include "HyperLink.h"

class CAboutDlg : public CDialog {
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CHyperLink	m_cHyperlink;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_HYPERLINK, m_cHyperlink);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CAboutDlg::OnInitDialog() {
	CDialog::OnInitDialog();
	
	m_cHyperlink.SetURL("http://www.generation5.org/index.shtml");
	
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAStarDlg dialog

CAStarDlg::CAStarDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAStarDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAStarDlg)
	m_bDisplayRoute = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
	memset(m_iBoard, 0, sizeof(m_iBoard));
	m_bDragging = m_bDrawRoute = false;

	// Set up the colours.
	m_crColIndex[0] = RGB(255,255,255);
	m_crColIndex[1] = RGB(204,204,204);
	m_crColIndex[2] = RGB(150,150,150);
	m_crColIndex[3] = RGB(119,119,119);
	m_crColIndex[4] = RGB(95,95,95);
	m_crColIndex[5] = RGB(0,0,0);
	m_crColIndex[6] = RGB(255,0,0);			// Start
	m_crColIndex[7] = RGB(0,128,0);			// Finish

	m_iCurLevel = 0;
	m_cStartPt.x = m_cStartPt.y = m_cFinishPt.x = m_cFinishPt.y = -1;
}

void CAStarDlg::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAStarDlg)
	DDX_Control(pDX, IDC_BOARD, m_cBoard);
	DDX_Control(pDX, IDC_BUTTON8, m_cEnd);
	DDX_Control(pDX, IDC_BUTTON7, m_cStart);
	DDX_Control(pDX, IDC_BUTTON6, m_cLevel5);
	DDX_Control(pDX, IDC_BUTTON5, m_cLevel4);
	DDX_Control(pDX, IDC_BUTTON4, m_cLevel3);
	DDX_Control(pDX, IDC_BUTTON3, m_cLevel2);
	DDX_Control(pDX, IDC_BUTTON2, m_cLevel1);
	DDX_Control(pDX, IDC_BUTTON1, m_cLevel0);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAStarDlg, CDialog)
	//{{AFX_MSG_MAP(CAStarDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_RESET, OnReset)
	//}}AFX_MSG_MAP

	ON_COMMAND_RANGE(IDC_BUTTON1, IDC_BUTTON8, OnLevelSelect)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAStarDlg message handlers

BOOL CAStarDlg::OnInitDialog() {
	CDialog::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL) {
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty()) {
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon((HICON)(LoadImage(AfxGetResourceHandle(), 
		MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON, 16, 16, 0)), FALSE);
	
	// Set up bitmap buttons
	m_cLevel0.LoadBitmaps(IDB_BITMAP1, IDB_BITMAP9);
	m_cLevel1.LoadBitmaps(IDB_BITMAP2, IDB_BITMAP10);
	m_cLevel2.LoadBitmaps(IDB_BITMAP3, IDB_BITMAP11);
	m_cLevel3.LoadBitmaps(IDB_BITMAP4, IDB_BITMAP12);
	m_cLevel4.LoadBitmaps(IDB_BITMAP5, IDB_BITMAP13);
	m_cLevel5.LoadBitmaps(IDB_BITMAP6, IDB_BITMAP14);
	m_cStart.LoadBitmaps(IDB_BITMAP7, IDB_BITMAP15);
	m_cEnd.LoadBitmaps(IDB_BITMAP8, IDB_BITMAP16);

	m_cBoard.GetClientRect(&m_cBoardRect);
	int dx = (m_cBoardRect.Width()/10)*10;
	int dy = (m_cBoardRect.Height()/10)*10;

	m_cBoard.SetWindowPos(NULL,10,10,dx,dy,SWP_NOZORDER);
	m_cBoard.GetClientRect(&m_cBoardRect);
	m_cBoard.ClientToScreen(&m_cBoardRect);
	ScreenToClient(m_cBoardRect);
	m_cBoardRect.InflateRect(1,1);

	m_iCurLevel = 0;
	m_crCurColour = m_crColIndex[0];

	return TRUE;
}

void CAStarDlg::OnSysCommand(UINT nID, LPARAM lParam) {
	if ((nID & 0xFFF0) == IDM_ABOUTBOX) {
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	} else {
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAStarDlg::OnPaint() {
	if (IsIconic()) {
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	} else {
		CPaintDC dc(this);
		CDialog::OnPaint();
		
		CBrush br(RGB(0,0,0));
		
		dc.FillSolidRect(m_cBoardRect, RGB(255,255,255));
		dc.FrameRect(&m_cBoardRect, &br);

		int col = 0;
		COLORREF cr;
		for (int i=0;i<30;i++) {
			for (int j=0;j<20;j++) {
				col = m_iBoard[i][j];
			
				if (!col) continue;

				cr = m_crColIndex[col];
				CRect rect(CPoint(i*10+10,j*10+10), CSize(10,10));
				dc.FillSolidRect(rect, cr);
			}
		}

		if (m_cStartPt != CPoint(-1,-1)) {
			CRect rect(CPoint(m_cStartPt.x*10+10, m_cStartPt.y*10+10), CSize(10,10));
			dc.FillSolidRect(rect, RGB(255,0,0));
		}
		
		if (m_cFinishPt != CPoint(-1,-1)) {
			CRect rect(CPoint(m_cFinishPt.x*10+10, m_cFinishPt.y*10+10), CSize(10,10));
			dc.FillSolidRect(rect, RGB(0,128,0));
		}

		if (m_bDrawRoute) {
			_asNode *best = m_cAStar.GetBestNode();
			
			int x,y;
			CClientDC dc(this);
			while (best) {
				x = best->x;
				y = best->y;

				dc.FillSolidRect(CRect(CPoint(x*10+10,y*10+10), CSize(10,10)), RGB(0,0,128));

				best = best->parent;
			}
		}
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAStarDlg::OnQueryDragIcon() {
	return (HCURSOR) m_hIcon;
}

void CAStarDlg::OnLevelSelect(UINT uID) {
	m_crCurColour = m_crColIndex[m_iCurLevel = uID-IDC_BUTTON1];

	m_bStart = m_bFinish = false;
	if (uID == IDC_BUTTON7) m_bStart = true;
	if (uID == IDC_BUTTON8) m_bFinish = true;
}


void CAStarDlg::OnLButtonDown(UINT nFlags, CPoint point) {
	PlotPoint(point);

	if (!m_bStart && !m_bFinish) m_bDragging = true;

	CDialog::OnLButtonDown(nFlags, point);
}

void CAStarDlg::OnMouseMove(UINT nFlags, CPoint point) {
	if (!m_bDragging) return;

	PlotPoint(point);

	CDialog::OnMouseMove(nFlags, point);
}

void CAStarDlg::PlotPoint(CPoint point) {
	CRect rect = m_cBoardRect;
	rect.DeflateRect(1,1);

	if (!rect.PtInRect(point)) return;

	CClientDC dc(this);

	int px = point.x/10-1, py = point.y/10-1;

	CPoint pt(px,py), round(px*10+10, py*10+10);
	rect = CRect(round, CSize(10,10));

	if (pt != m_cStartPt && pt != m_cFinishPt)
		dc.FillSolidRect(rect, m_crCurColour);

	CPoint old;
	if (m_bStart || m_bFinish) {
		if (m_bStart) {
			round.x = m_cStartPt.x*10+10;
			round.y = m_cStartPt.y*10+10;
			CRect rect(round, CSize(10,10));

			old = m_cStartPt;
			m_cStartPt = pt;
			
			if (m_cStartPt != old && old != CPoint(-1, -1)) {
				COLORREF cr = m_crColIndex[m_iBoard[old.x][old.y]];
				dc.FillSolidRect(rect, cr);
			}
		} else {
			round.x = m_cFinishPt.x*10+10;
			round.y = m_cFinishPt.y*10+10;
			CRect rect(round, CSize(10,10));

			old = m_cFinishPt;
			m_cFinishPt = pt;
			
			if (m_cFinishPt != old && old != CPoint(-1, -1)) {
				COLORREF cr = m_crColIndex[m_iBoard[old.x][old.y]];
				dc.FillSolidRect(rect, cr);
			}
		}
	} else m_iBoard[px][py] = m_iCurLevel;
}


void CAStarDlg::OnLButtonUp(UINT nFlags, CPoint point) {
	m_bDragging = false;
	
	CDialog::OnLButtonUp(nFlags, point);
}

void CAStarDlg::OnStart() {
	if (m_cStartPt == CPoint(-1, -1) || m_cFinishPt == CPoint(-1,-1)) {
		MessageBox("Please select both start and finish positions", "A* Demonstrator", MB_ICONWARNING|MB_OK);
		return;
	}
	
	m_cAStar.SetRows(30);
	m_cAStar.SetValid(Valid);
	m_cAStar.SetCost(Cost);
	m_cAStar.SetData(reinterpret_cast<void *>(this));

	if (m_cAStar.GeneratePath(m_cStartPt.x, m_cStartPt.y, m_cFinishPt.x, m_cFinishPt.y)) {
		m_bDrawRoute = true;
		InvalidateRect(m_cBoardRect, false);
	} else {
		m_bDrawRoute = false;
		InvalidateRect(m_cBoardRect, false);

		MessageBox("A path cannot be found.", "A* Demonstration", MB_ICONINFORMATION|MB_OK);
	}
}

int CAStarDlg::Valid(int x, int y, void *pointer) {
	CAStarDlg *dlg = reinterpret_cast<CAStarDlg *>(pointer);

	if (x < 0 || y < 0 || x >= 30 || y >= 20) return FALSE;
	if (dlg->m_iBoard[x][y] == 5) return FALSE;

	return TRUE;
}

int CAStarDlg::Cost(int x, int y, void *pointer) {
	CAStarDlg *dlg = reinterpret_cast<CAStarDlg *>(pointer);

	int cost = dlg->m_iBoard[x][y]+1;

	// Since distance is not 
	// sqrt'ed, square this.
	return cost * cost;
}

void CAStarDlg::OnReset() {
	memset(m_iBoard, 0, sizeof(m_iBoard));

	m_bDrawRoute = false;
	m_cStartPt = m_cFinishPt = CPoint(-1, -1);
	InvalidateRect(m_cBoardRect, false);
}
