#ifndef _AFX_ASTARDLG_H_
#define _AFX_ASTARDLG_H_

#if _MSC_VER >= 1000
#pragma once
#endif 

#include "PathFinder.h"

#define	START	6			// Colour indices.
#define FINISH	7			// for start and finish

class CAStarDlg : public CDialog {
public:
	CAStarDlg(CWnd* pParent = NULL);

	//{{AFX_DATA(CAStarDlg)
	enum { IDD = IDD_ASTAR_DIALOG };
	CStatic	m_cBoard;
	CBitmapButton	m_cEnd;
	CBitmapButton	m_cStart;
	CBitmapButton	m_cLevel5;
	CBitmapButton	m_cLevel4;
	CBitmapButton	m_cLevel3;
	CBitmapButton	m_cLevel2;
	CBitmapButton	m_cLevel1;
	CBitmapButton	m_cLevel0;
	BOOL	m_bDisplayRoute;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CAStarDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

	// Static functions.
	static int Valid(int, int, void *);
	static int Cost(int, int, void *);

protected:
	bool	m_bDrawRoute;
	bool	m_bDragging;				// Is the user dragging the mouse?
	bool	m_bStart, m_bFinish;		// Have we selected start or finish buttons?
	int		m_iBoard[30][20];			// Hard coded from board...terrible, I know.
	int		m_iCurLevel;

	COLORREF m_crCurColour;
	COLORREF m_crColIndex[8];
	HICON	m_hIcon;

	CPathFinder	m_cAStar;
	
	CPoint	m_cStartPt;
	CPoint	m_cFinishPt;
	CRect	m_cBoardRect;

	void PlotPoint(CPoint pt);
	
	//{{AFX_MSG(CAStarDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnStart();
	afx_msg void OnReset();
	//}}AFX_MSG

	afx_msg void OnLevelSelect(UINT);

	DECLARE_MESSAGE_MAP()
};
//{{AFX_INSERT_LOCATION}}

#endif
